/*
    w32loader
    copyright (c) 1998-2008 Kazuki IWAMOTO http://www.maid.org/ iwm@maid.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __HTMLHELP_H__
#define __HTMLHELP_H__


#include "windows.h"


G_BEGIN_DECLS


#define HH_DISPLAY_TOPIC        0x0000
#define HH_DISPLAY_TOC          0x0001
#define HH_DISPLAY_INDEX        0x0002
#define HH_DISPLAY_SEARCH       0x0003
#define HH_SET_WIN_TYPE         0x0004
#define HH_GET_WIN_TYPE         0x0005
#define HH_GET_WIN_HANDLE       0x0006
#define HH_SYNC                 0x0009
#define HH_KEYWORD_LOOKUP       0x000d
#define HH_DISPLAY_TEXT_POPUP   0x000e
#define HH_HELP_CONTEXT         0x000f
#define HH_TP_HELP_CONTEXTMENU  0x0010
#define HH_TP_HELP_WM_HELP      0x0011
#define HH_CLOSE_ALL            0x0012
#define HH_ALINK_LOOKUP         0x0013
#define HH_GET_LAST_ERROR       0x0014
#define HH_INITIALIZE           0x001c
#define HH_UNINITIALIZE         0x001d
#define HH_PRETRANSLATEMESSAGE  0x00fd


HWND WINAPI HtmlHelpA (HWND hwndCaller, LPCSTR pszFile, UINT uCommand, DWORD dwData);
HWND WINAPI HtmlHelpW (HWND hwndCaller, LPCWSTR pszFile, UINT uCommand, DWORD dwData);
#ifdef UNICODE
# define HtmlHelp HtmlHelpW
#else /* not UNICODE */
# define HtmlHelp HtmlHelpA
#endif /* not UNICODE */


G_END_DECLS


#endif /* __HTMLHELP_H__ */
