/*
    w32loader
    copyright (c) 1998-2007 Kazuki IWAMOTO http://www.maid.org/ iwm@maid.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "version.h"
#include "kernel32.h"


/* GetFileVersionInfoA ordinal = 1, argument = 16 */
BOOL WINAPI GetFileVersionInfoA (LPSTR lptstrFilename, DWORD dwHandle, DWORD dwLen, LPVOID lpData)
{
  return FALSE;
}


/* GetFileVersionInfoSizeA ordinal = 2, argument = 8 */
DWORD WINAPI GetFileVersionInfoSizeA (LPSTR lptstrFilename, LPDWORD lpdwHandle)
{
  if (lpdwHandle)
    *lpdwHandle = 0;
  return 0;
}


/* GetFileVersionInfoSizeW ordinal = 3, argument = 8 */
DWORD WINAPI GetFileVersionInfoSizeW (LPWSTR lptstrFilename, LPDWORD lpdwHandle)
{
  if (lpdwHandle)
    *lpdwHandle = 0;
  return 0;
}


/* GetFileVersionInfoW ordinal = 4, argument = 16 */
BOOL WINAPI GetFileVersionInfoW (LPWSTR lptstrFilename, DWORD dwHandle, DWORD dwLen, LPVOID lpData)
{
  return FALSE;
}


/* VerFindFileA ordinal = 5, argument = 32 temporary */
static DWORD WINAPI VerFindFileA (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3, DWORD dwArgv4, DWORD dwArgv5, DWORD dwArgv6, DWORD dwArgv7)
{
  return 0;
}


/* VerFindFileW ordinal = 6, argument = 32 temporary */
static DWORD WINAPI VerFindFileW (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3, DWORD dwArgv4, DWORD dwArgv5, DWORD dwArgv6, DWORD dwArgv7)
{
  return 0;
}


/* VerInstallFileA ordinal = 7, argument = 32 temporary */
static DWORD WINAPI VerInstallFileA (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3, DWORD dwArgv4, DWORD dwArgv5, DWORD dwArgv6, DWORD dwArgv7)
{
  return 0;
}


/* VerInstallFileW ordinal = 8, argument = 32 temporary */
static DWORD WINAPI VerInstallFileW (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3, DWORD dwArgv4, DWORD dwArgv5, DWORD dwArgv6, DWORD dwArgv7)
{
  return 0;
}


/* VerLanguageNameA ordinal = 9, argument = 12 conflict */
static DWORD WINAPI version_VerLanguageNameA (DWORD wLang, LPSTR szLang, DWORD nSize)
{
  return VerLanguageNameA (wLang, szLang, nSize);
}


/* VerLanguageNameW ordinal = 10, argument = 12 conflict */
static DWORD WINAPI version_VerLanguageNameW (DWORD wLang, LPWSTR szLang, DWORD nSize)
{
  return VerLanguageNameW (wLang, szLang, nSize);
}


/* VerQueryValueA ordinal = 11, argument = 16 */
BOOL WINAPI VerQueryValueA (LPCVOID pBlock, LPSTR lpSubBlock, LPVOID *lplpBuffer, UINT_PTR puLen)
{
  return FALSE;
}


/* VerQueryValueIndexA ordinal = 12, argument = 24 temporary */
static DWORD WINAPI VerQueryValueIndexA (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3, DWORD dwArgv4, DWORD dwArgv5)
{
  return 0;
}


/* VerQueryValueIndexW ordinal = 13, argument = 24 temporary */
static DWORD WINAPI VerQueryValueIndexW (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3, DWORD dwArgv4, DWORD dwArgv5)
{
  return 0;
}


/* VerQueryValueW ordinal = 14, argument = 16 */
BOOL WINAPI VerQueryValueW (LPCVOID pBlock, LPWSTR lpSubBlock, LPVOID *lplpBuffer, UINT_PTR puLen)
{
  return FALSE;
}


W32LdrExport version_exports[] = {
{TRUE,   1, "GetFileVersionInfoA",     GetFileVersionInfoA},
{TRUE,   2, "GetFileVersionInfoSizeA", GetFileVersionInfoSizeA},
{TRUE,   3, "GetFileVersionInfoSizeW", GetFileVersionInfoSizeW},
{TRUE,   4, "GetFileVersionInfoW",     GetFileVersionInfoW},
{FALSE,  5, "VerFindFileA",            VerFindFileA},
{FALSE,  6, "VerFindFileW",            VerFindFileW},
{FALSE,  7, "VerInstallFileA",         VerInstallFileA},
{FALSE,  8, "VerInstallFileW",         VerInstallFileW},
{FALSE,  9, "VerLanguageNameA",        version_VerLanguageNameA},
{FALSE, 10, "VerLanguageNameW",        version_VerLanguageNameW},
{TRUE,  11, "VerQueryValueA",          VerQueryValueA},
{FALSE, 12, "VerQueryValueIndexA",     VerQueryValueIndexA},
{FALSE, 13, "VerQueryValueIndexW",     VerQueryValueIndexW},
{TRUE,  14, "VerQueryValueW",          VerQueryValueW},
{FALSE,  0, NULL,                      NULL}};
